//#include<aspic.h>
//#include<as16f877a.h>
#include<htc.h>

#asm 
	PORTD equ 0x008
	Sec2 equ 0x04C
#endasm

#define rs RD4
#define rw RD5
#define en RD6
#define rs_out      {nRBPU=0; TRISD4=0; rs=0;}
#define rw_out      {nRBPU=0; TRISD5=0; rw=0;}
#define en_out      {TRISD6=0; en=0;}
#define Dlcd_Config {TRISC=0; PORTC=0;}

unsigned char tempB,press,flg;
unsigned char Sec, Min, Hour, Day, Date, Month, Year;
unsigned char s1,s2,m1,m2,h1,h2,dy1,dy2,dt1,dt2,mn1,mn2,yr1,yr2;
unsigned char *Day_Name[]={"SUN","MON","TUE","WED","THU","FRI","SAT"};
unsigned char lcd_thresold=1, count, x, n=0, line=1;

void Delay(unsigned int y)
{
unsigned int r;
for(r=0;r<y;r++);
}

void write_cmd(unsigned char a)
{
     Delay(200);
     TRISA=0;
     TRISC=0;
     rs=0;
     rw=0;
     PORTC=a;
     en=1;
     Delay(2);
     en=0;
}

void write_data(unsigned char c)
{
     TRISA=0;
     TRISC=0;
     Delay(200);
     rs=1;
     rw=0;
     PORTC=c;
     en=1;
     Delay(2);
     en=0;
}

LCD_cursor(unsigned char row, unsigned char column)
{
   unsigned char t;
	write_cmd(0x0C);
     if(row==1)
     {
      write_cmd(0x80);
      for(t=0;t<column;t++)
      {
      Delay(100);
      write_cmd(0x14);
      }
     }
     if(row==2)
     {
      write_cmd(0xC0);
      for(t=0;t<column;t++)
      {
      Delay(100);
      write_cmd(0x14);
      }
     }
}

void LCD_puts(unsigned char *f)        // String's first address is stored at f and here comes the address of f(that is *f)
{
        int x=0;
        while (f[x])                         // If the data on address is not 'o' then proceed. (Pointer to array)
        {
                write_data(f[x]);                 // write the data resides at the address of first array of f(f[1]).
                x++;                           // Increment the address so we can put on further data as well(f[2],f[3],...upto end of string.
        }
}

void LCD_Init()
{
     rs_out; rw_out; en_out;
     Dlcd_Config;
     Delay(100);
     write_cmd(0x38);
     Delay(100);
     write_cmd(0x01);
      Delay(100);
     write_cmd(0x0c);
}

void load(unsigned int l)
{
unsigned char buff;
// if(l==0);
 	  if(l==0) { x=s1; lcd_thresold=7;  line=1;}
 else if(l==1) { x=s2; lcd_thresold=8;  line=1;}
 else if(l==2) { x=m1; lcd_thresold=10; line=1;}
 else if(l==3) { x=m2; lcd_thresold=11; line=1;}
 else if(l==4) { x=h1; lcd_thresold=13; line=1;}
 else if(l==5) { x=h2; lcd_thresold=14; line=1;}
}

void store(unsigned int l)
{
 if(l==0);
 	  if(l==1) s1=x;
 else if(l==2) s2=x;
 else if(l==3) m1=x;
 else if(l==4) m2=x;
 else if(l==5) h1=x;
 else if(l==6) h2=x;
}

void switch_press()
{
	//	TRISB = 0;    //for debugging.
        n=0;
loop1:
		PORTD=x;
		PORTB&=0xF0;
		while(PORTB==0xF0);
		switch(PORTB)
		{
          case(0xE0):
          {
			store(n);
			load(n);
			n++;
            LCD_cursor(line,lcd_thresold);
            write_cmd(0x0F);       // cursor Blink
            PORTD=n;
            break;
          }

          case(0xD0):
          {
             write_cmd(0x0C);   //cursor off
             if(n==1) { if(x<0x32) x++; }
             if(n==2) { if(s1==0x32){ if(x<0x33) x++;} else if(x<0x39) x++;}
             x=x|0x30;
             write_data(x);
             write_cmd(0x10); //cursor left
             write_cmd(0x0F); //Blink
             break;
          }

          case(0xB0):
          { 
			 write_cmd(0x0C);   //cursor off
             if(x>0x30){x--; x=x|0x30; PORTD=x;}
			 write_data(x);
             write_cmd(0x10); //cursor left
             write_cmd(0x0F); //Blink
             break; 
          }

          case(0x70):
          { 
			write_cmd(0x0C); // cursor off
			 store(n);
            goto loop3;
          }
		} 
		while(PORTB!=0xF0);
        goto loop1;

loop3: 
		s1<<=4;
		s1&=0xF0;
		s2&=0x0F;
		Sec=s1|s2; Min=m1|m2; Hour=h1|h2;
 }


void interrupt isr()
{    
	 switch_press();                                                        
     PORTD=Sec; 
}



void main()
{
  TRISD=0;
  s1=1; s2=2;
  s1=s1|0x30;
  s2=s2|0x30;
//----------------------          // temporary
/*		STATUS =0;
		Sec=0x45;
	 while(1);
	
*/
//----------------------
 /*
   m1=Min&0xF0; m2=Min&0x0F;
  h1=Hour&0xF0; h2=Hour&0x0F;
 */


  LCD_Init();
  LCD_cursor(1,7);
  write_data(s1);
  write_data(s2);
  write_data(0x3A);
  write_cmd(0x0E);


  
PORTD=0x00;
  TRISB=0xF0;  
  PORTB=0xF0;
  nRBPU=0;
  RBIE=1;
  GIE=1;
//switch_press(); // for debugging.
  while(1);
}

